#!/bin/bash

VERSION=5
PRODUCT_SERIAL="$(sudo cat /sys/devices/virtual/dmi/id/product_serial)"
RELEASE_CFG=tsfw3.cfg
CURRENT_CFG=dump.cfg


if lsusb -d 03eb:212c | grep -c Atmel > /dev/null 2>&1 ; then
	if [ -f /usr/local/bin/ti/$PRODUCT_SERIAL ] ; then
		if [ "$(cat "/usr/local/bin/ti/$PRODUCT_SERIAL")" = "$VERSION" ] ; then
			echo "Touch Configuration File On System Is Same Version As Update"
			echo "No Update Needed!"
			exit
		fi
	fi
	echo "Getting Touch Configuration From System"
	/usr/local/bin/ti/./mxt-app --save /usr/local/bin/ti/$(CURRENT_CFG)

	#Check if dump.cfg from system is the same as load.cfg firmware file, ignore lines lines 6 and 7.
	#These lines are output diagnostic information fields and correspond to T44 and T5 in the Object-Base Server menu.
	if diff <(sed '6,7d' /usr/local/bin/ti/$CURRENT_CFG) <(sed '6,7d' /usr/local/bin/ti/$RELEASE_CFG) > /dev/null 2>&1 ; then
		echo "Touch Configuration File On System Matches Update"
	else
		echo "Touch Configuration File On System Differs From Update"
		echo "Loading New Configuration"
		/usr/local/bin/ti/./mxt-app --load /usr/local/bin/ti/$RELEASE_CFG
	fi
	echo "Updating Version To $VERSION"
	echo "$VERSION" > /usr/local/bin/ti/$PRODUCT_SERIAL
else
	echo "This does not contain a Atmel touch controller"
fi
echo "Update Complete"
